// 3DDoc.cpp : implementation file
//

#include "stdafx.h"
#include "3DDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "SetSizeDlg.h"
#include "SceneParamsDlg.h"
#include "3DView.h"
/////////////////////////////////////////////////////////////////////////////
// C3DDoc

IMPLEMENT_DYNCREATE(C3DDoc, CDocument)

C3DDoc::C3DDoc()
{
	scene = NULL;
}

BOOL C3DDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	scene = new CScene(100.0, 100.0);
	scene->AddListener(50.0, 50.0);
	scene->SetGrid(1, 1, true);
	UpdateAllViews(NULL);

	return TRUE;
}

C3DDoc::~C3DDoc()
{
}


BEGIN_MESSAGE_MAP(C3DDoc, CDocument)
	//{{AFX_MSG_MAP(C3DDoc)
		ON_COMMAND(ID_SETSIZES, OnSetsizes)
	ON_COMMAND(ID_SCENEPARAMS, OnSceneparams)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C3DDoc diagnostics

#ifdef _DEBUG
void C3DDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void C3DDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// C3DDoc serialization

void C3DDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		scene->SaveAll(ar);
	}
	else
	{
		// TODO: add loading code here
		scene = new CScene();
		scene->LoadAll(ar);
	}
}

/////////////////////////////////////////////////////////////////////////////
// C3DDoc commands


void C3DDoc::OnSetsizes() 
{
	// TODO: Add your command handler code here
	CSetSizeDlg sizedlg;
	sizedlg.m_HorzSize = scene->GetWidth();
	sizedlg.m_VertSize = scene->GetHeight();
	sizedlg.m_GridX = scene->GetGridX();
	sizedlg.m_GridY = scene->GetGridY();
	sizedlg.m_AlignToGrid = scene->GetAlign();

	if (sizedlg.DoModal() != IDOK) return;

	if (!scene->SetSizes(sizedlg.m_HorzSize, sizedlg.m_VertSize) &&
		!scene->SetGrid(sizedlg.m_GridX, sizedlg.m_GridY, (sizedlg.m_AlignToGrid == 1)))
		return;

	SetModifiedFlag();
	UpdateAllViews(NULL);
}

void C3DDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	if (scene != NULL)
	{
		POSITION pos = GetFirstViewPosition();
		C3DView *v = (C3DView *)GetNextView(pos);
		delete scene;	
		scene = NULL;
		if (v != NULL) v->scene = NULL;
	}
}


void C3DDoc::OnSceneparams() 
{
	// TODO: Add your command handler code here
	CSceneParamsDlg paramdlg;
	SceneProperty *p = scene->GetSceneProperty();

	memcpy(&paramdlg.m_Params, p, sizeof(SceneProperty));
	if (paramdlg.DoModal() != IDOK) return;	
	memcpy(p, &paramdlg.m_Params, sizeof(SceneProperty));

	SetModifiedFlag();
}

BOOL C3DDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		OnNewDocument();
	return TRUE;
}
