#if !defined(AFX_3DVIEW_H__53DCC722_1227_11D5_B5F1_5254AB134FE2__INCLUDED_)
#define AFX_3DVIEW_H__53DCC722_1227_11D5_B5F1_5254AB134FE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// 3DView.h : header file
//

#include "3DDoc.h"
/////////////////////////////////////////////////////////////////////////////
// C3DView view

class C3DView : public CScrollView
{
private:
	CRect rect;
	int m_Mode;
	bool m_Moving;
	int old_x, old_y;
	bool XYToSceneCoord(int x, int y, double &x2, double &y2);
	bool SceneToXYCoord(double x, double y, int &x2, int &y2);
	void UpdateScrollers();
	int m_Scale;
	bool m_Pressed;
	CSceneObject *selected;
	void DrawListener(C3DDoc *pDoc, CDC *dc);
	void UpdateScale();
	CDC *GetDC();
	bool CheckScene(bool MsgIfOk);
protected:
	DECLARE_DYNCREATE(C3DView)

// Attributes
public:
	CScene *scene;
	C3DView();
	C3DDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(C3DView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~C3DView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(C3DView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDrawrect();
	afx_msg void OnUpdateDrawrect(CCmdUI* pCmdUI);
	afx_msg void OnMoveobj();
	afx_msg void OnUpdateMoveobj(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSelectobj(CCmdUI* pCmdUI);
	afx_msg void OnSelectobj();
	afx_msg void OnUpdateDelobj(CCmdUI* pCmdUI);
	afx_msg void OnDelobj();
	afx_msg void OnUpdateAddsound(CCmdUI* pCmdUI);
	afx_msg void OnAddsound();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnUpdateObjprop(CCmdUI* pCmdUI);
	afx_msg void OnObjprop();
	afx_msg void OnUpdateZoomin(CCmdUI* pCmdUI);
	afx_msg void OnZoomin();
	afx_msg void OnUpdateZoomout(CCmdUI* pCmdUI);
	afx_msg void OnZoomout();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnCheckscene();
	afx_msg void OnCalceffect();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in 3DView.cpp
inline C3DDoc* C3DView::GetDocument()
   { return (C3DDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_3DVIEW_H__53DCC722_1227_11D5_B5F1_5254AB134FE2__INCLUDED_)
