// ChorusDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dsp.h"
#include "ChorusDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChorusDlg dialog


CChorusDlg::CChorusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChorusDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChorusDlg)
	m_ApplyTo = -1;
	m_ChorusAmp = 0;
	m_ChorusDelay = 10;
	m_ChorusSize = 3;
	m_InputAmp = 0;
	m_ModDepth = 100;
	m_ModFreq = 0.1;
	//}}AFX_DATA_INIT
}


void CChorusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChorusDlg)
	DDX_CBIndex(pDX, IDC_APPLYTO, m_ApplyTo);
	DDX_Slider(pDX, IDC_CHORUSAMP, m_ChorusAmp);
	DDX_Text(pDX, IDC_CHORUSDELAY, m_ChorusDelay);
	DDV_MinMaxInt(pDX, m_ChorusDelay, 1, 100);
	DDX_Text(pDX, IDC_CHORUSSIZE, m_ChorusSize);
	DDV_MinMaxInt(pDX, m_ChorusSize, 1, 5);
	DDX_Slider(pDX, IDC_INPUTAMP, m_InputAmp);
	DDX_Text(pDX, IDC_MODDEPTH, m_ModDepth);
	DDV_MinMaxInt(pDX, m_ModDepth, 1, 100);
	DDX_Text(pDX, IDC_MODFREQ, m_ModFreq);
	DDV_MinMaxDouble(pDX, m_ModFreq, 0.1, 20.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChorusDlg, CDialog)
	//{{AFX_MSG_MAP(CChorusDlg)
	ON_WM_VSCROLL()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChorusDlg message handlers

void CChorusDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int id = -1, pos;
	double p;

	CSliderCtrl *sl = (CSliderCtrl *)pScrollBar;
	char s[20];

	switch (sl->GetDlgCtrlID())
	{
		case IDC_INPUTAMP: id = IDC_VAL1; break;
		case IDC_CHORUSAMP: id = IDC_VAL2; break;
	}

	if (id > 0)
	{
		pos = -sl->GetPos();
		if (pos > -80)
		{
			p = pow(10, (double)pos / 20) * 100;
			sprintf(s, "%d \n(%.2f%c)", pos, p, '%');
		}
		else
			strcpy(s, "-Inf \n(0%)");
		SetDlgItemText(id, s);
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

BOOL CChorusDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	if (!m_ApplyTo)
	{
		CComboBox *cb = (CComboBox *)GetDlgItem(IDC_APPLYTO);
		cb->DeleteString(1);
	}
	CSliderCtrl *sl = (CSliderCtrl *)GetDlgItem(IDC_INPUTAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(80);
	sl->SetTicFreq(6);
	sl = (CSliderCtrl *)GetDlgItem(IDC_CHORUSAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(80);
	sl->SetTicFreq(6);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChorusDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_INPUTAMP));
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_CHORUSAMP));
}
