// PoleZeroDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dsp.h"
#include "PoleZeroDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPoleZeroDlg dialog


CPoleZeroDlg::CPoleZeroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPoleZeroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPoleZeroDlg)
	m_R = 0.0;
	m_W = 0.0;
	m_FreqMeasure = 0;
	//}}AFX_DATA_INIT
}


void CPoleZeroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	double max;
	//{{AFX_DATA_MAP(CPoleZeroDlg)
	DDX_Text(pDX, IDC_R, m_R);
	DDV_MinMaxDouble(pDX, m_R, 0., 100.0);
	DDX_Text(pDX, IDC_W, m_W);
	DDX_Radio(pDX, IDC_FREQMEASURE, m_FreqMeasure);
	switch (m_FreqMeasure)
	{
		case 0: max = M_PI; break;
		case 1: max = 180; break;
		case 2: max = 0.5; break;
		case 3: max = m_HalfRate;
	}
	DDV_MinMaxDouble(pDX, m_W, 0., max);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPoleZeroDlg, CDialog)
	//{{AFX_MSG_MAP(CPoleZeroDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPoleZeroDlg message handlers

BOOL CPoleZeroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	char s[64];
	sprintf(s, "&  \n(0 - %d )", m_HalfRate);
	SetDlgItemText(IDC_FREQ, s);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

double CPoleZeroDlg::ConvertFromW()
{
	switch (m_FreqMeasure)
	{
		case 1: return m_W / M_PI * 180;
		case 2: return m_W / M_PI * 0.5;
		case 3: return m_W / M_PI * m_HalfRate;
	}
	return m_W;
}

void CPoleZeroDlg::ConvertToW(double w)
{
	switch (m_FreqMeasure)
	{
		case 0: m_W = w; break;
		case 1: m_W = w * M_PI / 180; break;
		case 2: m_W = w * M_PI / 0.5; break;
		case 3: m_W = w * M_PI / m_HalfRate;
	}
}


void CPoleZeroDlg::OnOK() 
{
	// TODO: Add extra validation here
	CDialog::OnOK();
	ConvertToW(m_W);
}
